static struct sexp_huff_entry huff_table[] = {
 {12, 0x0C00},   /* '\x00' */
 {15, 0x0000},   /* '\x01' */
 {15, 0x4000},   /* '\x02' */
 {15, 0x2000},   /* '\x03' */
 {15, 0x6000},   /* '\x04' */
 {15, 0x0800},   /* '\x05' */
 {15, 0x4800},   /* '\x06' */
 {15, 0x2800},   /* '\x07' */
 {15, 0x6800},   /* '\x08' */
 {15, 0x1800},   /* '\x09' */
 {15, 0x5800},   /* '\x0a' */
 {15, 0x3800},   /* '\x0b' */
 {15, 0x7800},   /* '\x0c' */
 {15, 0x0100},   /* '\x0d' */
 {15, 0x4100},   /* '\x0e' */
 {15, 0x2100},   /* '\x0f' */
 {15, 0x6100},   /* '\x10' */
 {15, 0x1100},   /* '\x11' */
 {15, 0x5100},   /* '\x12' */
 {15, 0x3100},   /* '\x13' */
 {15, 0x7100},   /* '\x14' */
 {15, 0x0900},   /* '\x15' */
 {15, 0x4900},   /* '\x16' */
 {15, 0x2900},   /* '\x17' */
 {15, 0x6900},   /* '\x18' */
 {15, 0x1900},   /* '\x19' */
 {15, 0x5900},   /* '\x1a' */
 {15, 0x3900},   /* '\x1b' */
 {15, 0x7900},   /* '\x1c' */
 {15, 0x0500},   /* '\x1d' */
 {15, 0x4500},   /* '\x1e' */
 {15, 0x2500},   /* '\x1f' */
 {15, 0x6500},   /* '\x20' */
 { 8, 0x0040},   /* '!'   */
 {15, 0x1500},   /* '"'   */
 {15, 0x5500},   /* '#'   */
 {15, 0x3500},   /* '$'   */
 {15, 0x7500},   /* '%'   */
 {15, 0x0D00},   /* '&'   */
 {15, 0x4D00},   /* '\''  */
 {15, 0x2D00},   /* '('   */
 {15, 0x6D00},   /* ')'   */
 {11, 0x0300},   /* '*'   */
 {10, 0x0180},   /* '+'   */
 {15, 0x1D00},   /* ','   */
 { 4, 0x000D},   /* '-'   */
 {15, 0x5D00},   /* '.'   */
 {10, 0x0380},   /* '/'   */
 {15, 0x3D00},   /* '0'   */
 {15, 0x7D00},   /* '1'   */
 {14, 0x0080},   /* '2'   */
 {14, 0x2080},   /* '3'   */
 {14, 0x1080},   /* '4'   */
 {14, 0x3080},   /* '5'   */
 {14, 0x0880},   /* '6'   */
 {14, 0x2880},   /* '7'   */
 {14, 0x1880},   /* '8'   */
 {14, 0x3880},   /* '9'   */
 {14, 0x0480},   /* ':'   */
 {14, 0x2480},   /* ';'   */
 { 7, 0x0050},   /* '<'   */
 { 7, 0x0042},   /* '='   */
 { 7, 0x0022},   /* '>'   */
 { 5, 0x0009},   /* '?'   */
 {14, 0x1480},   /* '@'   */
 {14, 0x3480},   /* 'A'   */
 {14, 0x0C80},   /* 'B'   */
 {14, 0x2C80},   /* 'C'   */
 {14, 0x1C80},   /* 'D'   */
 {14, 0x3C80},   /* 'E'   */
 {14, 0x0280},   /* 'F'   */
 {14, 0x2280},   /* 'G'   */
 {14, 0x1280},   /* 'H'   */
 {14, 0x3280},   /* 'I'   */
 {14, 0x0A80},   /* 'J'   */
 {14, 0x2A80},   /* 'K'   */
 {14, 0x1A80},   /* 'L'   */
 {14, 0x3A80},   /* 'M'   */
 {14, 0x0680},   /* 'N'   */
 {14, 0x2680},   /* 'O'   */
 {14, 0x1680},   /* 'P'   */
 {14, 0x3680},   /* 'Q'   */
 {14, 0x0E80},   /* 'R'   */
 {14, 0x2E80},   /* 'S'   */
 {14, 0x1E80},   /* 'T'   */
 {14, 0x3E80},   /* 'U'   */
 {14, 0x0200},   /* 'V'   */
 {14, 0x2200},   /* 'W'   */
 {14, 0x1200},   /* 'X'   */
 {14, 0x3200},   /* 'Y'   */
 {14, 0x0A00},   /* 'Z'   */
 {14, 0x2A00},   /* '['   */
 {14, 0x1A00},   /* '\\'  */
 {14, 0x3A00},   /* ']'   */
 {14, 0x0600},   /* '^'   */
 {14, 0x2600},   /* '_'   */
 {14, 0x1600},   /* '`'   */
 { 3, 0x0007},   /* 'a'   */
 { 7, 0x0020},   /* 'b'   */
 { 4, 0x0004},   /* 'c'   */
 { 5, 0x001A},   /* 'd'   */
 { 4, 0x0006},   /* 'e'   */
 { 7, 0x0002},   /* 'f'   */
 { 5, 0x0011},   /* 'g'   */
 { 6, 0x0012},   /* 'h'   */
 { 4, 0x000C},   /* 'i'   */
 {12, 0x0400},   /* 'j'   */
 { 8, 0x00C0},   /* 'k'   */
 { 5, 0x0018},   /* 'l'   */
 { 6, 0x0032},   /* 'm'   */
 { 4, 0x0005},   /* 'n'   */
 { 5, 0x000A},   /* 'o'   */
 { 5, 0x0001},   /* 'p'   */
 { 7, 0x0070},   /* 'q'   */
 { 3, 0x0003},   /* 'r'   */
 { 5, 0x0008},   /* 's'   */
 { 4, 0x000E},   /* 't'   */
 { 5, 0x0019},   /* 'u'   */
 { 7, 0x0062},   /* 'v'   */
 { 7, 0x0030},   /* 'w'   */
 { 7, 0x0060},   /* 'x'   */
 { 7, 0x0010},   /* 'y'   */
 {11, 0x0700},   /* 'z'   */
 {14, 0x3600},   /* '{'   */
 {14, 0x0E00},   /* '|'   */
 {14, 0x2E00},   /* '}'   */
 {14, 0x1E00},   /* '~'   */
 {14, 0x3E00}    /* '\x7f' */
};
